package edu.jhu.cs.oose.fall2010.group1.surveyApp.model;

import java.util.List;

/**
 * <code>ChoiceQuestion</code> that allows a subset of the choices to be selected.
 * The response is represented as an array of booleans.
 * 
 * @author liu
 *
 * @param <T> the type of object to represent the choices
 */

public class MultiChoiceQuestion<T> extends ChoiceQuestion<T> {

	/**
	 * Sole Constructor
	 * 
	 * @param newPrompt prompt for this question
	 * @param choices list of choices to choose from
	 * @throws InvalidChoiceListException if choice list is null
	 */
	public MultiChoiceQuestion(String newPrompt, List<T> choices) throws InvalidChoiceListException {
		super(newPrompt, Boolean[].class, choices);
	}

	@Override
	public boolean validate(Object answer) {
		return super.validate(answer) && ((Boolean[])answer).length == super.getNumberOfChoices();
	}

	@Override
	public List<Statistic> aggregate(List<Object> listOfAnswers) {
		return null;
	}
	
}