package edu.jhu.cs.oose.fall2010.group1.surveyApp.model.tests;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;

import edu.jhu.cs.oose.fall2010.group1.surveyApp.model.BinaryChoice;
import edu.jhu.cs.oose.fall2010.group1.surveyApp.model.BinaryChoiceQuestion;

public class BinaryChoiceQuestionTest {

	@Test
	public void testMakeBinaryChoiceQuestion() {
		BinaryChoiceQuestion<String> BCQ1 = BinaryChoiceQuestion.makeBinaryChoiceQuestion("Are you well today?", "No", "Yes");
		
		assertTrue(BCQ1.getPrompt().equals("Are you well today?"));
		
		List<BinaryChoice<String>> choiceList = new ArrayList<BinaryChoice<String>>();
		choiceList.add(new BinaryChoice<String>(false, "No"));
		choiceList.add(new BinaryChoice<String>(true, "Yes"));
		
		assertTrue(BCQ1.getChoices().equals(choiceList));
		assertTrue(BCQ1.validate(true));
		assertTrue(BCQ1.validate(false));
		assertFalse(BCQ1.validate(10));
		assertFalse(BCQ1.validate(null));
		assertTrue(BCQ1.getNumberOfChoices() == 2);
	}

}
