package edu.jhu.cs.oose.fall2010.group1.surveyApp.model.tests;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.junit.Test;

import edu.jhu.cs.oose.fall2010.group1.surveyApp.model.InvalidChoiceListException;
import edu.jhu.cs.oose.fall2010.group1.surveyApp.model.MultiChoiceQuestion;

public class MultiChoiceQuestionTest {

	@Test
	public void testMakeMultiChoiceQuestion() {
		try {
			MultiChoiceQuestion<String> MCQ1 = new MultiChoiceQuestion<String>("There are no answers to this question.", new ArrayList<String>());
			
			assertTrue(MCQ1.getPrompt().equals("There are no answers to this question."));
			
			List<String> choiceList = MCQ1.getChoices();
			
			assertTrue(choiceList.equals(new ArrayList<String>()));
			
			choiceList.add("Some Choice");
			
			assertFalse(MCQ1.getChoices().equals(choiceList));
			
			assertTrue(MCQ1.getNumberOfChoices() == 0);
			assertTrue(MCQ1.validate(new Boolean[0]));
			assertFalse(MCQ1.validate(null));
			assertFalse(MCQ1.validate(new Boolean[1]));
			assertFalse(MCQ1.validate(0));
		} catch (InvalidChoiceListException e) {
			assertTrue(false);
		}
		
		try {
			List<String> choiceList2 = new ArrayList<String>();
			for (int i = 0; i < 3; i++)
				choiceList2.add(Integer.toString(i));
			MultiChoiceQuestion<String> MCQ2 = new MultiChoiceQuestion<String>("There are 3 answers to this question.", choiceList2);
			
			choiceList2.remove(0);
			
			assertFalse(MCQ2.getChoices() == choiceList2);
			assertTrue(MCQ2.getNumberOfChoices() == 3);
			assertTrue(MCQ2.validate(new Boolean[3]));
			assertFalse(MCQ2.validate(new Boolean[2]));
			assertFalse(MCQ2.validate(new Boolean[4]));
			assertFalse(MCQ2.validate(null));
			assertFalse(MCQ2.validate((new Random()).nextInt()));
		} catch (InvalidChoiceListException e) {
			assertTrue(false);
		}
		
		try {
			MultiChoiceQuestion<String> MCQ2 = new MultiChoiceQuestion<String>("This should give an error", null);
			assertTrue(false);
			MCQ2.getNumberOfChoices();
		} catch (InvalidChoiceListException e){
			assertTrue(true);
		}
	}

}
